unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, directshow9,ActiveX, VSFilter, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);


  private
    { Private declarations }
  public
    { Public declarations }
  end;
const
// CLSID        Graphedit  Graphstudio
CLSID_DirectVobSub  : TGUID = '{93A22E7A-5091-45EF-BA61-6DA26156A5D0}';

var
  Form1: TForm1;
  FGraphBuilder: IGraphBuilder = Nil;
  FCaptureGraphBuilder: ICaptureGraphBuilder2 = nil;
  FMediaControl: IMediaControl = Nil;
  FVideoWindow: IVideoWindow   = Nil;
  FDirectVobSub   : IBaseFilter = nil;
  FAudioRender : IBaseFilter = nil;
  FVideoRender : IBaseFilter = nil;
  fl_SrcFile     : IBaseFilter = nil;
  //  DirectVobSub
  DirectVobSub: IDirectVobSub = nil;
  //   
  FileNameVideo:String;
  //  
  FileNameText:String;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
//  
 if Assigned(FMediaControl) then FMediaControl:= NIL;
 if Assigned(FVideoWindow)  then FVideoWindow := NIL;
 if Assigned(FAudioRender)  then FAudioRender := nil;
 if Assigned(FVideoRender)  then  FVideoRender:= nil;
 if Assigned(FDirectVobSub)  then FDirectVobSub:= nil;
 if Assigned(FCaptureGraphBuilder) then FCaptureGraphBuilder   := NIL;
 if Assigned(FGraphBuilder) then FGraphBuilder:= NIL;

//    
CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, FGraphBuilder);
//    
CoCreateInstance(CLSID_CaptureGraphBuilder2, NIL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, FCaptureGraphBuilder);
//   
FCaptureGraphBuilder.SetFiltergraph(FGraphBuilder);
//    
OpenDialog1.Title:='  ';
if OpenDialog1.Execute then FileNameVideo:=OpenDialog1.FileName;
//             
FGraphBuilder.AddSourceFilter(StringToOleStr(FileNameVideo),'',fl_SrcFile);
//   DirectVobSub
CoCreateInstance(CLSID_DirectVobSub, nil, CLSCTX_INPROC, IID_IBaseFilter, FDirectVobSub);
//   
FGraphBuilder.AddFilter(FDirectVobSub, 'DirectVobSub');
//    
OpenDialog1.Title:='  ';
if OpenDialog1.Execute then FileNameText:=OpenDialog1.FileName;
//     
(FDirectVobSub as IDirectVobSub).put_FileName(StringToOleStr(FileNameText));
//      
CoCreateInstance(CLSID_AudioRender, nil, CLSCTX_INPROC, IID_IBaseFilter, FAudioRender);
FGraphBuilder.AddFilter(FAudioRender, 'DirectSound Audio Renderer');
//      
CoCreateInstance(CLSID_VideoMixingRenderer, nil, CLSCTX_INPROC, IID_IBaseFilter, FVideoRender);
FGraphBuilder.AddFilter(FVideoRender, 'Video Renderer');
//      
with FCaptureGraphBuilder do
begin
//  wmv
if lowercase(ExtractFileExt(FileNameVideo))='.wmv' then  begin
   //       fl_SrcFile    FDirectVobSub
   if FAILED(RenderStream(nil,  @MEDIATYPE_Video, fl_SrcFile, nil , FDirectVobSub)) then
   Begin
      ShowMessage('!         fl_SrcFile    FDirectVobSub');
      Exit;
    End;
//  
end  else   begin
         //       fl_SrcFile    FDirectVobSub
         if FAILED(RenderStream(nil, @MEDIATYPE_Stream, fl_SrcFile, nil ,FDirectVobSub)) then
             Begin
                ShowMessage('!         fl_SrcFile    FDirectVobSub');
                Exit;
              End;
            end;

//    
   if FAILED(RenderStream(nil, nil, fl_SrcFile, nil, FAudioRender)) then
   Begin
      ShowMessage('!      ');
      Exit;
    End;
//        FDirectVobSub   FVideoRender
  if FAILED(RenderStream(nil, @MEDIATYPE_Video, FDirectVobSub, nil, FVideoRender)) then
   Begin
      ShowMessage('!       FDirectVobSub   FVideoRender');
      Exit;
   End;
end;
 //  ImediaControl
FGraphBuilder.QueryInterface(IID_IMediaControl, FMediaControl);
 //  IVideoWindow
FGraphBuilder.QueryInterface(IID_IVideoWindow, FVideoWindow);
//    Panel1
 FVideoWindow.put_Owner(Panel1.Handle);
 FVideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
 FVideoWindow.put_MessageDrain(Panel1.Handle);
 FVideoWindow.SetWindowPosition(0, 0, Panel1.ClientRect.Right,Panel1.ClientRect.Bottom);
 //  
 FMediaControl.Run;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//   com
FMediaControl:= NIL;
FVideoWindow := NIL;
FAudioRender := nil;
FVideoRender:= nil;
FDirectVobSub:= nil;
FCaptureGraphBuilder   := NIL;
FGraphBuilder:= NIL;
CoUninitialize;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
// com
CoInitialize(nil);
end;

end.
